#! /bin/bash

# script to find lines and replace, lines commented out are ignored


# function to call awk and implement find and replace
function find_and_replace () {

   # comment character, lines to ignor and print
   local f_comment_ch=$1
   # line in file to find and replace
   local f_look_for=$2
   # replacement line
   local f_replace_with=$3
   # original filename
   local f_filename=$4

   # make sure the directory exists
   if [ ! -f "$f_filename" ]; then
      echo ""
      echo $f_filename
      echo "cannot be found"
      echo ""
      exit 1
   fi

   # test print
   echo "   in function"
   echo "  f_comment_ch: " $f_comment_ch
   echo "    f_look_for: " $f_look_for
   echo "f_replace_with: " $f_replace_with
   echo "    f_filename: " $f_filename
   echo ""

   # add variables to ENVIRON
   export f_comment_ch  f_look_for  f_replace_with

   # process each file with awk to extact specific information
   awk ' { if( substr($0,1,1) == ENVIRON["f_comment_ch"] ||
               substr($0,1,2) == ENVIRON["f_comment_ch"] )
              print $0;
           else if($0 ~ ENVIRON["f_look_for"])
              print ENVIRON["f_replace_with"];
           else
              print $0;
         } ' $f_filename > tmp
   # overwrite original file
   mv tmp $f_filename

   # clear variables set fot this call to awk
   unset f_comment_ch
   unset f_look_for
   unset f_replace_with

}


#----------------------------------------------------------------------------------------
# this value is calculated by other code
total_outputs='2099'
# add 1 to total outputs for the rest of the values
total_outputs_p1=$(($total_outputs + 1))

#----------------------------------------------------------------------------------------
# replace value of SIZEXX in src_common_depend/UTILPARAMS.DAT

# file being modified
filename='./common_depend/UTILPARAMS.DAT'
# comment lines to ignore
comment_ch="C"
# line being searched for to replace
look_for="      PARAMETER \(SIZEXX = "
# value of line being replaced
replace_with="      PARAMETER (SIZEXX = $total_outputs_p1)"

# call find and replace
find_and_replace  "$comment_ch"  "$look_for"  "$replace_with"  "$filename"


#----------------------------------------------------------------------------------------
# replace value of LASTINDEX in ./common_depend/sizedefs.h

# file being modified
filename='./common_depend/sizedefs.h'
# comment lines to ignore
comment_ch='//'
# line being searched for to replace, may contain escape characters
look_for="\#define LASTINDEX"
# value of line being replaced, characters do not need to be escaped here
replace_with="#define LASTINDEX   $total_outputs"

# call find and replace
find_and_replace  "$comment_ch"  "$look_for"  "$replace_with"  "$filename"

#----------------------------------------------------------------------------------------
echo "finished find and replace"
echo ""
